package helion.r3;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
 * <p>Title: JBuilder X. Efektywne programowanie w Javie</p>
 * <p>Description: rda wicze z ksiki "JBuilder X. Efektywne programowanie w Javie"</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>WWW: <A HREF="http://www.phys.uni.torun.pl/~jacek/dydaktyka/helion/jbuilderx/">http://www.phys.uni.torun.pl/~jacek/dydaktyka/helion/jbuilderx/</A></p>
 * @author Jacek Matulewski
 * @version 1.0
 */

public class Scrollbars extends Applet {
  private boolean isStandalone = false;
  Scrollbar scrollbar1 = new Scrollbar();
  Scrollbar scrollbar2 = new Scrollbar();
  Scrollbar scrollbar3 = new Scrollbar();
  Panel panel1 = new Panel();
  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public Scrollbars() {
  }
  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception {
    this.setLayout(null);
    scrollbar1.setMaximum(255);
    scrollbar1.setOrientation(0);
    scrollbar1.setBounds(new Rectangle(25, 15, 340, 25));
    scrollbar1.addAdjustmentListener(new Scrollbars_scrollbar1_adjustmentAdapter(this));
    scrollbar2.setMaximum(255);
    scrollbar2.setOrientation(0);
    scrollbar2.setBounds(new Rectangle(25, 53, 340, 25));
    scrollbar2.addAdjustmentListener(new Scrollbars_scrollbar2_adjustmentAdapter(this));
    scrollbar3.setMaximum(255);
    scrollbar3.setOrientation(0);
    scrollbar3.setBounds(new Rectangle(25, 92, 340, 25));
    scrollbar3.addAdjustmentListener(new Scrollbars_scrollbar3_adjustmentAdapter(this));
    panel1.setBackground(Color.black);
    panel1.setBounds(new Rectangle(26, 133, 341, 147));
    this.setBackground(SystemColor.window);
    this.add(scrollbar1, null);
    this.add(scrollbar2, null);
    this.add(scrollbar3, null);
    this.add(panel1, null);
  }
  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }
  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }

  void scrollbar1_adjustmentValueChanged(AdjustmentEvent e) {
    panel1.setBackground(new Color(scrollbar1.getValue(),
                                   scrollbar2.getValue(),
                                   scrollbar3.getValue()));
    showStatus("RGB: "+scrollbar1.getValue()+", "+scrollbar2.getValue()+", "+scrollbar3.getValue());
  }
}

class Scrollbars_scrollbar1_adjustmentAdapter implements java.awt.event.AdjustmentListener {
  Scrollbars adaptee;

  Scrollbars_scrollbar1_adjustmentAdapter(Scrollbars adaptee) {
    this.adaptee = adaptee;
  }
  public void adjustmentValueChanged(AdjustmentEvent e) {
    adaptee.scrollbar1_adjustmentValueChanged(e);
  }
}

class Scrollbars_scrollbar2_adjustmentAdapter implements java.awt.event.AdjustmentListener {
  Scrollbars adaptee;

  Scrollbars_scrollbar2_adjustmentAdapter(Scrollbars adaptee) {
    this.adaptee = adaptee;
  }
  public void adjustmentValueChanged(AdjustmentEvent e) {
    adaptee.scrollbar1_adjustmentValueChanged(e);
  }
}

class Scrollbars_scrollbar3_adjustmentAdapter implements java.awt.event.AdjustmentListener {
  Scrollbars adaptee;

  Scrollbars_scrollbar3_adjustmentAdapter(Scrollbars adaptee) {
    this.adaptee = adaptee;
  }
  public void adjustmentValueChanged(AdjustmentEvent e) {
    adaptee.scrollbar1_adjustmentValueChanged(e);
  }
}
