package helion.xc;

import java.applet.Applet;
import java.awt.*;

/**
 * <p>Title: JBuilder X. Efektywne programowanie w Javie</p>
 * <p>Description: rda wicze z ksiki "JBuilder X. Efektywne programowanie w Javie"</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>WWW: <A HREF="http://www.phys.uni.torun.pl/~jacek/dydaktyka/helion/jbuilderx/">http://www.phys.uni.torun.pl/~jacek/dydaktyka/helion/jbuilderx/</A></p>
 * @author Jacek Matulewski
 * @version 1.0
 */

public class BufferedApplet extends Applet
  {
  protected boolean podwojne_buforowanie=true;
  private Image bufor=null; //bufor do zapisywania przez update, szybciej gdy zadeklarowany raz poza Update

  public BufferedApplet()
    {
    super();
    }

  public void update(Graphics g)
    {
    Rectangle dim=this.getBounds();
    int w=dim.width, h=dim.height;

    if (!this.isShowing()) return;

    if (podwojne_buforowanie)
      {
      //podwojne buforowanie - wyeliminowanie migotania (rysowanie poza ekranem i pokazanie gotowego na aplecie)
      if (bufor==null) bufor = this.createImage(w, h); //tworzenie bufora jezeli potrzebny

      Graphics bg=bufor.getGraphics(); //pobieram Graphics zwiazane z buforem
      bg.clearRect(0,0,w,h); //czyszczenie bufora
      bg.setClip(0,0,w,h); //Ustalenie polozenia i rozmiaru (calosc)
      this.paint(bg); //tu maluje do bufora

      g.drawImage(bufor,0,0,null); //maluje bufor na aplecie
      bg.dispose(); //zwalniam bufor
      }
      else
      {
      g.clearRect(0,0,w,h);
      paint(g);
      }
    }
}

