package helion.xc;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
 * <p>Title: JBuilder X. Efektywne programowanie w Javie</p>
 * <p>Description: rda wicze z ksiki "JBuilder X. Efektywne programowanie w Javie"</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>WWW: <A HREF="http://www.phys.uni.torun.pl/~jacek/dydaktyka/helion/jbuilderx/">http://www.phys.uni.torun.pl/~jacek/dydaktyka/helion/jbuilderx/</A></p>
 * @author Jacek Matulewski
 * @version 1.0
 */

public class Gradient extends Applet {
  private boolean isStandalone = false;
  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public Gradient() {
  }
  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception {
  }
  //Start the applet
  public void start() {
    repaint();
  }
  //Stop the applet
  public void stop() {
    repaint();
  }
  //Destroy the applet
  public void destroy() {
  }
  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }
  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }


  public void paint(Graphics g)
  {
    float barwa = (float) Math.random();
    showStatus("Barwa: "+barwa);
    int wysokosc = this.getBounds().height;

    for (int indeks = 0; indeks < wysokosc; indeks++)
      {
      float jasnosc = indeks / (float) (wysokosc - 1); //ustalenie jasnosci
      Color kolor = Color.getHSBColor(barwa, 1, jasnosc); //stworzenie koloru
      g.setColor(kolor); //ustalenie koloru w jakim rysujemy
      //g.setColor(Color.getHSBColor(barwa,1,indeks/(float)(wysokosc-1)));
      g.drawLine(0, indeks, this.getBounds().width, indeks); //narysowanie linii
      }
  }

}
